#include "Menu.h"

const char * ButtonName[CountOfButtons] = { "1", "Pick Card    ", 
											"2", "Select Card  ",
					                        "3", "Select Letter",
											"4", "Trade        ",
											"5", "Discard      ",
											"6", "Form Word    ",
											"7", "Cancel       ",
											"8", "End  Round   ",
											"9", "Quit         "};


CMenu::CMenu()
{
	for (int i=0; i<CountOfButtons; i++)
	{
		this->buttons[i].setValue(ButtonName[i]);
		this->buttons[i].setBKGroundColor(DefaultMenuBKGroundColor);
		if (i%2 == 0)
		{
			this->buttons[i].setFontColor(FTRED);
		}
		else
		{
			this->buttons[i].setFontColor(DefaultMenuFontColor);
		}
	}
	selected=-1;
}

void CMenu::setSelected(int index)
{
	if (selected!=index&&index!=-1)
	{
		//restore first
		if (selected!=-1)
		{
			setBKGroundColor(selected, DefaultMenuBKGroundColor);
		}
		setBKGroundColor(index, DefaultMenuSelectedBKGroundColor);
		selected=index;
		show();
	}
}


void CMenu::show()
{
	displayH(DefaultMenu_x, DefaultMenu_y);
}

//iButton--the index of button, theColor--the color value
bool CMenu::setFontColor(int iButton, WORD theColor)
{
	this->buttons[iButton*2+1].setFontColor(theColor);
	return true;
}
	
//iButton--the index of button, theColor--the color value
bool CMenu::setBKGroundColor(int iButton, WORD theColor)
{
	this->buttons[iButton*2+1].setBKGroundColor(theColor);
	return true;
}

void CMenu::displayH(int x, int y)
{
	for (int i=0; i<CountOfButtons; i++)
	{
		this->buttons[i].display(x, y);

		if ( i==7 )
			y++, x=0;
		
		if (i%2==1 && i!=0 && i!=7)
			x += strlen(ButtonName[i]) + MenuSpace;
		else
			x++;
	}
}

void CMenu::displayV(int x, int y)
{
	int xb=x;
	for (int i=0; i<CountOfButtons; i++)
	{
		this->buttons[i].display(x, y);
		if ( i%2 == 1 )
			y+=2, x=xb;
		else 
			x++;
	}
}