#include "tokens.h"


void CTokens::shuffle()
{
	for (int num=0; num<6; num++)//shuffle number
	{
		for (int i=0; i<len-1; i++)
		{
			int j=0;
			while (j<=i)
			{
				j=rand()%len;
			}
			CToken temp;
			temp=tokens[i];
			tokens[i]=tokens[j];
			tokens[j]=temp;
		}
	}
}

CTokens::CTokens(int theLen)
{
	initialize();
	setLength(theLen);
}

CTokens::CTokens(const char* str)
{
	initialize();
	setValue(str);
}

bool CTokens::popToken(CToken& token)
{
	if (pos!=0)
	{
		token= tokens[--pos];
		return true;
	}
	else
	{
		return false;
	}
}

bool CTokens::pushToken(const CToken& token)
{
	if (pos+1<len)
	{
		tokens[pos++]=token;
		return true;
	}
	else
	{
		return false;
	}
}

void CTokens::initialize()
{
	len=0;
	tokens=NULL;
	isVertical=false;
	ftColor=DefaultFontColor;
	bkColor=DefaultBKGroundColor;
	frColor=DefaultFrameColor;
	pos=0;
}

void CTokens::setBKGroundColor(WORD theColor)
{
	for (int i=0; i<len; i++)
	{
		tokens[i].setBKGroundColor(theColor);
	}
}

void CTokens::setFontColor(WORD theColor)
{
	for (int i=0; i<len; i++)
	{
		tokens[i].setFontColor(theColor);
	}
}

void CTokens::setFrameColor(WORD theColor)
{
	for (int i=0; i<len; i++)
	{
		tokens[i].setFrameColor(theColor);
	}
}

void CTokens::setLength(int size)
{
	if (len!=size)
	{
		delete []tokens;
		len=size;
		tokens=new CToken[len];
	}
}


void CTokens::setValue(const char* str)
{
	setLength(strlen(str));
	for (int i=0; i<len; i++)
	{
		tokens[i].setValue(str[i]);
	}
}

void CTokens::display(int x, int y)
{
	for (int i=0; i<len; i++)
	{
		if (!isVertical)
		{
			if (x>DefaultScreenWidth-5)
			{
				y+=4;
				x=0;
			}
			tokens[i].display(x, y);
			x+=4;
		}
		else
		{
			if (y>DefaultScreenHeight-5)
			{
				x+=4;
				y=0;
			}
			tokens[i].display(x, y);
			y+=4;
		}
	}
}

CTokens::~CTokens()
{
	delete [] tokens;	
}